#include "paging.h"

bool Paging::reserve(Accessor *accessor)
{
    _lock.lock();

    return _mappers.find(accessor) != _mappers.end();
}

PageMapper *Paging::get(Accessor *accessor)
{
    AccessorMapping::iterator entry = _mappers.find(accessor);
    PageMapper *mapper;

    if (entry == _mappers.end())
        mapper = NULL;
    else
        mapper = entry->second;

    _lock.unlock();
    return mapper;
}

void Paging::set(Accessor *accessor, PageMapper *mapper)
{
    AccessorMapping::iterator entry = _mappers.find(accessor);

    if (entry == _mappers.end())
        _mappers[accessor] = mapper;

    _lock.unlock();
}

// vim: tabstop=4 expandtab shiftwidth=4
